
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class LotsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const lots = await db.lots.create(
            {
                id: data.id || undefined,
        
        lot_number: data.lot_number
        ||
        null
            ,
            
        manufactured_at: data.manufactured_at
        ||
        null
            ,
            
        received_at: data.received_at
        ||
        null
            ,
            
        expiration_at: data.expiration_at
        ||
        null
            ,
            
        quality_status: data.quality_status
        ||
        null
            ,
            
        quantity_on_hand: data.quantity_on_hand
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await lots.setItem( data.item || null, {
            transaction,
        });
        
        await lots.setPlant( data.plant || null, {
            transaction,
        });
        
        await lots.setSupplier( data.supplier || null, {
            transaction,
        });
        
        await lots.setProduction_order( data.production_order || null, {
            transaction,
        });
        

        

        

        return lots;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const lotsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                lot_number: item.lot_number
            ||
            null
            ,
            
                manufactured_at: item.manufactured_at
            ||
            null
            ,
            
                received_at: item.received_at
            ||
            null
            ,
            
                expiration_at: item.expiration_at
            ||
            null
            ,
            
                quality_status: item.quality_status
            ||
            null
            ,
            
                quantity_on_hand: item.quantity_on_hand
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const lots = await db.lots.bulkCreate(lotsData, { transaction });

        // For each item created, replace relation files
        

        return lots;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const lots = await db.lots.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.lot_number !== undefined) updatePayload.lot_number = data.lot_number;
        
        
        if (data.manufactured_at !== undefined) updatePayload.manufactured_at = data.manufactured_at;
        
        
        if (data.received_at !== undefined) updatePayload.received_at = data.received_at;
        
        
        if (data.expiration_at !== undefined) updatePayload.expiration_at = data.expiration_at;
        
        
        if (data.quality_status !== undefined) updatePayload.quality_status = data.quality_status;
        
        
        if (data.quantity_on_hand !== undefined) updatePayload.quantity_on_hand = data.quantity_on_hand;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await lots.update(updatePayload, {transaction});

        
        
        if (data.item !== undefined) {
            await lots.setItem(
              
              data.item,
              
              { transaction }
            );
        }
        
        if (data.plant !== undefined) {
            await lots.setPlant(
              
              data.plant,
              
              { transaction }
            );
        }
        
        if (data.supplier !== undefined) {
            await lots.setSupplier(
              
              data.supplier,
              
              { transaction }
            );
        }
        
        if (data.production_order !== undefined) {
            await lots.setProduction_order(
              
              data.production_order,
              
              { transaction }
            );
        }
        

        
        

        

        return lots;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const lots = await db.lots.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of lots) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of lots) {
                await record.destroy({transaction});
            }
        });


        return lots;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const lots = await db.lots.findByPk(id, options);

        await lots.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await lots.destroy({
            transaction
        });

        return lots;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const lots = await db.lots.findOne(
            { where },
            { transaction },
        );

        if (!lots) {
            return lots;
        }

        const output = lots.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.serial_numbers_lot = await lots.getSerial_numbers_lot({
            transaction
        });
        
        
        output.inventory_transactions_lot = await lots.getInventory_transactions_lot({
            transaction
        });
        
        
        output.inspections_lot = await lots.getInspections_lot({
            transaction
        });
        
        
        
        output.nonconformances_lot = await lots.getNonconformances_lot({
            transaction
        });
        
        
        output.quality_holds_lot = await lots.getQuality_holds_lot({
            transaction
        });
        
        
        
        
        
        output.item = await lots.getItem({
            transaction
        });
        
        
        output.plant = await lots.getPlant({
            transaction
        });
        
        
        output.supplier = await lots.getSupplier({
            transaction
        });
        
        
        output.production_order = await lots.getProduction_order({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.items,
        as: 'item',
        
        where: filter.item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.plants,
        as: 'plant',
        
        where: filter.plant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.plant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.plant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.suppliers,
        as: 'supplier',
        
        where: filter.supplier ? {
          [Op.or]: [
            { id: { [Op.in]: filter.supplier.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.supplier.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.production_orders,
        as: 'production_order',
        
        where: filter.production_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.production_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.lot_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'lots',
                        'lot_number',
                        filter.lot_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'lots',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.manufactured_atRange) {
                const [start, end] = filter.manufactured_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    manufactured_at: {
                    ...where.manufactured_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    manufactured_at: {
                    ...where.manufactured_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.received_atRange) {
                const [start, end] = filter.received_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    received_at: {
                    ...where.received_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    received_at: {
                    ...where.received_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expiration_atRange) {
                const [start, end] = filter.expiration_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expiration_at: {
                    ...where.expiration_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expiration_at: {
                    ...where.expiration_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantity_on_handRange) {
                const [start, end] = filter.quantity_on_handRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_on_hand: {
                    ...where.quantity_on_hand,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_on_hand: {
                    ...where.quantity_on_hand,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.quality_status) {
                where = {
                    ...where,
                quality_status: filter.quality_status,
            };
            }
            


      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.lots.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'lots',
                        'lot_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.lots.findAll({
            attributes: [ 'id', 'lot_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['lot_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.lot_number,
        }));
    }

    
};

